*=$4000
charmap=$1000
;fonts $20,$24
;colors
 lda #32 ; 32-red,202/250-green
 sta 708

 lda #144 ; blue
 sta 709

 lda #70 ; 255-yellow
 sta 710


;
 lda #dli_12&255
 sta $230

 lda #dli_12/256
 sta $231
; build charmap
v1 = $CB
bw = $CC
wavcnt = $CD
 lda #0
 sta v1
 tay

chlp2
 lda #charmap&255
 sta chp+1
 lda #charmap/256
 sta chp+2

; lda #$20
; sta 756
 
 ldx #$8
chlp1
 lda v1
 and #$7F
 inc v1
chp sta charmap,y
 lda chp+1
 clc
 adc #32+8
 bcc no_h1
 inc chp+2
no_h1
 sta chp+1
 dex
 bne chlp1
 iny
 cpy #16+24
 bne chlp2
;------------------------------------------------
;755,$D401
wavy_lp
 jsr wait_frame
fontp lda #$20
 sta 756
 sta $D409 ; shadow
 eor #$04
 sta fontp+1
 sta fntp+1
 sta eorfill+1

 cmp #$20
 beq fontc_20
 jsr clear24
 jmp stopc
fontc_20
 jsr clear20
stopc

 lda #$80
 sta wavlp2+1
sv1 ldy #0
 dey
 sty sv1+1
sv2 ldx #0
 inx
 inx
 stx sv2+1
 jsr drawsin

 lda #$40
 sta wavlp2+1
sv4 ldy #5
 dey
 dey
 sty sv4+1
sv5 ldx #7
 inx
 stx sv5+1
 jsr drawsin
 jsr eorfill


 jmp wavy_lp

drawsin
; !
fntp lda #0
 sta fontp1+2
 sta fontp2+2
;
 lda #0
 sta sv3+1
 sta fontp1+1
 sta fontp2+1

 lda #$20
 sta wavcnt
wavlp2 lda #$80 ; C0, $80
 sta bw
wavlp1
 lda wavsin,X
 clc
 adc wavsin,Y
 clc
sv3 adc #0
 sta fontp1+1
 sta fontp2+1
 lda bw
fontp1 ora $2000
fontp2 sta $2000

.rept 4
 inx ; 4 times?
.endr

.rept 8
 dey
.endr

 lsr bw
 lsr bw
 lda bw
 cmp #0
 bne wavlp1
 lda sv3+1
 clc
 adc #64
 bcc no_h2
 inc fontp1+2
 inc fontp2+2
no_h2
 sta sv3+1

 dec wavcnt
 bne wavlp2
 rts
;------------EOR fill ----------------------
eorfill lda #$20
 sta v1+1
 lda #0
 sta v1
 ldx #16-1

eo_lp
 ldy #0
 lda (v1),y
 iny
.rept 63
 eor (v1),y
 sta (v1),y
 iny
.endr
;
 lda v1
 clc
 adc #64
 bcc no_h3
 inc v1+1
no_h3
 sta v1
;
 dex
 bmi quit_ef
 jmp eo_lp
quit_ef
 rts
; ldy #$00
;eorf_lp
; lda $2000,Y
;r .= 1
;.rept 63
; eor $2000+r,Y
; sta $2000+r,Y
;r .=r + 1
;.endr
;-----clear memory
clear20
 lda #0
 tay
cl20lp
 sta $2000,y
 sta $2080,y

 sta $2100,y
 sta $2180,y
 
 sta $2200,y
 sta $2280,y
 
 sta $2300,y
 sta $2380,y
 iny
 bpl cl20lp
 rts

clear24
 lda #0
 tay
cl24lp
 sta $2400,y
 sta $2480,y

 sta $2500,y
 sta $2580,y

 sta $2600,y
 sta $2680,y

 sta $2700,y
 sta $2780,y

 iny
 bpl cl24lp
 rts

;------------------------------------------------
wait_frame
RTCLOK = $0012
      lda RTCLOK+2
waits
      cmp RTCLOK+2
       beq waits
 rts
;------------------------------------------------
dli_12
.byte $70,$70,$70
.byte $44
.word charmap

.rept 23
.byte 4
.endr
.byte $41
.word dli_12
;23 04,$41,dli_12
wavsin
.incbin "wavsin.bin"